use strict;
#use warnings;
undef $/;

use File::Basename;
use File::Copy;
use File::Find;
use FindBin qw($Bin);

my $exePath=$FindBin::Bin;



my $infile = "pnas_sample.xml";
my $outfile = "pnas_sample_out.xml";


open(IN,"<$infile") or die "$infile File not found"; 
my $data=<IN>;
close(IN);


#======== Date Time ===========

use Time::Piece;


my $DateTime = localtime->strftime('%d======/%m/%Y====%y: %H:%M:%S');

print $DateTime;

#31.12.2023: Sun:15:14:29;
#Sun Dec 31 15:14:29 2023

my $t = localtime;
print "\n\n\nTime is $t\n";
print "Year is ", $t->year, "\n";

$t->datetime;

print "\n$t\n"; 


#-------------------
#count increment
#-------------------

my $i = 0;

$i = sprintf "%03d", $i;

$data =~ s/<p>/'<p id="para'.++$i.'">'/eg;


#------------
# count element
#------------

my ($surname) ="";

if($data=~m/(<surname>(.*?)<\/surname>)/sg)
{
	$surname=$1;
}


print "\n\$surname name = $surname\n";

while($data=~m/(<surname>(.*?)<\/surname>)/sg)
{
	$surname .=$1;
}

print "\n\$surname name = $surname\n";


my ($surname) = $data=~m/(<surname>(.*?)<\/surname>)/sg;

print "\n\$surname name = $surname\n";

my $surname = () = $data=~m/(<surname>)/sg;

print "\n\$surname count = $surname\n";


#============
#match concept
#===========

my $text = 'earlynowlate';
$text =~ /now/;
print "Prematch: \"$`\" Match: \"$&\" Postmatch: \"$'\"\n";

my $Line=$data;  #<aff id="aff-1"><label>a</label>
while($Line=~/(<aff id="([^\"]*)"><label>(.*?)<\/label>(.*?)<\/aff>)/sg)
{
	my $PM = $`; my $CM = $&; my $Line = $';
  	my $mdata="$1"; my $OID="$2"; my $label=$3;
  	$data=~s/<xref ref-type="aff" rid="$OID"\/>/<xref ref-type="aff" rid="$OID">$label<\/xref>/sgi;
}



print "This \Qquoting \ubusiness \Uhere isn't quite\E done yet,\E is it?";

#This quoting\ Business\ HERE\ ISN\'T\ QUITE\ done\ yet\, is it?


open(OUT,">$outfile");
print OUT "$data";
close(OUT);